import json
import math
import random
from collections import defaultdict
from pathlib import Path
from pprint import pprint
from typing import Dict

import lightgbm
import nashpy
import numpy as np
import pandas as pd
from tqdm import tqdm


from linear_bidder_gbm import AVERAGE_CTR, validation_path, BUDGET, LinearBidder

# {i: x[x["payprice"] == i]["click"].sum() / len(x[x["payprice"] == i]) for i in range(1, 301) if x[x["payprice"] == i]["click"].sum()}
CTR_WHEN_BID = {
    4: 0.0001924001924001924, 5: 4.431543728257739e-05, 6: 0.00192320901160794, 7: 8.217602103706138e-05,
    9: 9.531071292413267e-05, 10: 0.0002825523899222981, 11: 0.00041336955237982755, 12: 0.00028774908279979855,
    13: 0.0004837929366231253, 14: 0.0001600896502041143, 15: 0.0005744296733957, 16: 0.00022682166146867025,
    17: 0.0001556420233463035, 18: 0.0006143878462913316, 19: 0.00032297133629390393, 20: 0.00018496083454328546,
    21: 0.0002642968053123658, 22: 0.000517612444492876, 23: 0.00043159257660768235, 24: 0.00029004423174534117,
    25: 0.0004545110218922809, 26: 0.00038153376573826786, 27: 0.0004417351356126866, 28: 0.0007192027124216583,
    29: 0.0003526093088857546, 30: 0.0006746373824069562, 31: 0.00045986525947897265, 32: 0.0003771876885938443,
    33: 0.0004603256804188964, 34: 0.0005790387955993051, 35: 0.0010111223458038423, 36: 0.0005659309564233164,
    37: 0.0007218727441476745, 38: 0.00046382189239332097, 39: 0.00027434842249657066, 40: 0.0004006209624918624,
    41: 0.0006237747282124399, 42: 0.0007507507507507507, 43: 0.00045439054867658755, 44: 0.0006942997986530584,
    45: 0.0005026569007611662, 46: 0.00032223415682062297, 47: 0.00048753308260203373, 48: 0.0002429838415745353,
    49: 0.0003161555485298767, 50: 0.0002732688418866481, 51: 0.00025567600736346903, 52: 0.0005703516341814214,
    53: 0.0006041565973900435, 54: 0.0006850253459377997, 55: 0.0003031850386161997, 56: 0.0008100810081008101,
    57: 0.0006321112515802782, 58: 0.0009223390518354548, 59: 0.0001864975755315181, 60: 0.0006209076540979905,
    61: 0.000819366852886406, 62: 0.0009404809888485826, 63: 0.00041115039881588683, 64: 0.0006565988181221273,
    65: 0.0010765711209796797, 66: 0.00014895360095330305, 67: 0.0006607201850016518, 68: 0.00010836584308625921,
    69: 0.0005309969467675561, 70: 0.0010356342731538235, 71: 0.00044742729306487697, 72: 0.0005902316659288771,
    73: 0.0011748531433570803, 74: 0.00047909929332854237, 75: 0.0008020318139286192, 76: 0.001052170100832968,
    77: 0.0010136522274686922, 78: 0.000999000999000999, 79: 0.0003874467260751647, 80: 0.0007092301234639378,
    81: 0.0008778667837155712, 82: 0.0011266698857234831, 83: 0.00015971889474524837, 84: 0.0005916965254265145,
    85: 0.0011575190508343782, 86: 0.0006521739130434783, 87: 0.0009332711152589828, 88: 0.0005586049448681207,
    89: 0.0010336451496201354, 90: 0.0005571030640668524, 91: 0.0008135869012508898, 92: 0.0010330578512396695,
    93: 0.001241978886358932, 94: 0.0012795905310300703, 95: 0.0011705946620883408, 96: 0.00048796356538711777,
    97: 0.0015082956259426848, 98: 0.00042140750105351877, 99: 0.001530612244897959, 100: 0.0007303146992431284,
    101: 0.0010517575422086909, 102: 0.0011715089034676663, 103: 0.0009075782786265315, 104: 0.0025245441795231417,
    105: 0.0008674907829104315, 106: 0.001037344398340249, 107: 0.0006119951040391676, 108: 0.001999077348915885,
    109: 0.00117096018735363, 110: 0.00022598870056497175, 111: 0.00040160642570281126, 112: 0.0006282393591958537,
    113: 0.0008095527221210282, 114: 0.0009603841536614646, 115: 0.0015689350853108452, 116: 0.001226993865030675,
    117: 0.0004261666311527807, 118: 0.0008703220191470844, 119: 0.001889644746787604, 120: 0.0007088846880907373,
    121: 0.0011892177589852009, 122: 0.0019331676332504833, 123: 0.0020470829068577278, 124: 0.0006563833278634722,
    125: 0.0015936254980079682, 126: 0.0015212981744421906, 127: 0.0012506948304613673, 128: 0.0014934926392148496,
    129: 0.000914703864623828, 130: 0.0004939491232403062, 131: 0.002112676056338028, 132: 0.0011829652996845426,
    133: 0.0011382319463766283, 134: 0.0004930966469428008, 135: 0.0011467889908256881, 136: 0.00026518164942985947,
    137: 0.0005421523448088912, 138: 0.001070090957731407, 139: 0.00029394473838918284, 140: 0.0017791483809749733,
    141: 0.0007708119218910585, 142: 0.0009466708740927738, 143: 0.0013728720483250961, 144: 0.0011695906432748538,
    145: 0.0015205271160669033, 146: 0.0007109004739336493, 147: 0.0013203063110641669, 148: 0.00133461852153926,
    149: 0.00022655188038060717, 150: 0.000719527989638797, 151: 0.0008773029201654342, 152: 0.0020234722784297854,
    153: 0.0005788712011577424, 154: 0.003107734806629834, 155: 0.002638522427440633, 156: 0.0009655616350177019,
    157: 0.000546448087431694, 158: 0.0007363770250368188, 159: 0.003987594151528578, 160: 0.0013072505719221251,
    161: 0.0007920792079207921, 162: 0.0006015942246954429, 163: 0.001960015680125441, 164: 0.002027027027027027,
    165: 0.0017905102954341987, 166: 0.0012464942349641633, 167: 0.0009049773755656109, 168: 0.001529386060738475,
    169: 0.0020847810979847115, 170: 0.0020768431983385254, 171: 0.001987083954297069, 172: 0.0015552099533437014,
    173: 0.0003937007874015748, 174: 0.002228589621139764, 175: 0.0012594458438287153, 176: 0.001154068090017311,
    177: 0.001381079214757818, 178: 0.0021941854086670325, 179: 0.0037429819089207735, 180: 0.0006406149903907751,
    181: 0.0015866719555731853, 182: 0.0006060606060606061, 183: 0.0011806375442739079, 185: 0.0014423076923076924,
    186: 0.004422332780541736, 187: 0.001002004008016032, 188: 0.0013049151805132667, 189: 0.0009478672985781991,
    190: 0.0011299435028248588, 191: 0.001190003966679889, 192: 0.0008405715886803026, 193: 0.0020693222969477496,
    195: 0.0021953896816684962, 196: 0.000970873786407767, 197: 0.0020597322348094747, 198: 0.0024737167594310453,
    199: 0.001148105625717566, 200: 0.0005997600959616154, 201: 0.0012721794442584534, 202: 0.0016161616161616162,
    203: 0.0005449591280653951, 204: 0.001451378809869376, 205: 0.0010660980810234541, 206: 0.003246753246753247,
    207: 0.004, 208: 0.000898069151324652, 209: 0.002378686964795433, 210: 0.0007385524372230429,
    211: 0.0015376729882111738, 212: 0.0021861336664584633, 213: 0.0021321961620469083, 214: 0.0016181229773462784,
    215: 0.0014231499051233396, 216: 0.002411575562700965, 218: 0.0006180469715698393, 219: 0.00141643059490085,
    220: 0.0007499062617172854, 221: 0.0014862521674510775, 222: 0.0006309148264984228, 223: 0.003838771593090211,
    224: 0.0011111111111111111, 225: 0.0008507018290089324, 226: 0.0006971880083662561, 227: 0.004321988114532685,
    228: 0.0006844626967830253, 229: 0.0008305647840531562, 230: 0.0008849557522123894, 231: 0.0016611295681063123,
    232: 0.000784313725490196, 235: 0.0008453085376162299, 236: 0.0012340600575894694, 237: 0.001583531274742676,
    238: 0.0018181818181818182, 239: 0.004807692307692308, 240: 0.0005737234652897303, 242: 0.002652519893899204,
    244: 0.003444316877152698, 245: 0.0032520325203252032, 246: 0.0013404825737265416, 247: 0.0024937655860349127,
    248: 0.002886002886002886, 249: 0.0016722408026755853, 250: 0.00047778308647873863, 251: 0.004784688995215311,
    253: 0.0007535795026375283, 255: 0.0014903129657228018, 258: 0.0012315270935960591, 259: 0.0036101083032490976,
    260: 0.0008528784648187633, 261: 0.0010515247108307045, 266: 0.0029895366218236174, 267: 0.0016233766233766235,
    269: 0.005235602094240838, 270: 0.0013315579227696406, 271: 0.0011947431302270011, 272: 0.0015552099533437014,
    273: 0.00211864406779661, 275: 0.00741839762611276, 277: 0.0017482517482517483, 278: 0.002178649237472767,
    280: 0.0014738393515106854, 281: 0.0006571741511500548, 282: 0.0019120458891013384, 283: 0.0030165912518853697,
    285: 0.0022471910112359553, 286: 0.005791505791505791, 288: 0.0017421602787456446, 289: 0.0014577259475218659,
    293: 0.001447178002894356, 296: 0.0041841004184100415, 297: 0.005847953216374269, 298: 0.0036231884057971015,
    299: 0.006896551724137931, 300: 0.003472222222222222
}


def default(o):
    if isinstance(o, np.int64): return int(o)
    if isinstance(o, np.float64): return float(o)
    raise TypeError


class MultiAgentBidder:

    def __init__(self):

        self.validation_x, self.validation_y, self.validation_ids = self.load_validation()

        self.average_ctr = AVERAGE_CTR
        self.model = lightgbm.Booster(model_file="models/proper_types_full.model")

        self.predictions = self.model.predict(self.validation_x)

        self.length = len(self.validation_ids)
        self.max_bid_multiplier = 2
        self.max_bid = int(math.ceil(BUDGET / self.length * 12))

        self.bids = pd.read_csv(Path("results") / "val_bid_ma.csv", index_col="bidid")

        opponents = {
            "linear_120": "val_bid_price_linear_120.csv",
            "semi_linear_77_30": "val_bid_price_semi_linear_77_30.csv",
            "ortb1_300_290": "val_bid_price_ortb1_reduced2_300_290.csv",
            "ortb2_8.5e-07_32": "val_bid_price_ortb2_reduced2_4.7e-07_128.csv",
        }

        self.opponents_dfs: Dict[str, pd.DataFrame] = {}

        for k, flname in opponents.items():
            self.opponents_dfs[k] = pd.read_csv(Path("results") / flname, index_col="bidid")

        self.opponents_dfs["constant_85"] = pd.DataFrame({
            "bidprice": np.full((len(self.validation_ids, )), 85)
        }, index=self.validation_ids["bidid"].values)
        self.opponents_dfs["random_500_2500"] = pd.DataFrame({
            "bidprice": np.random.randint(500, 2500, size=(self.length))
        }, index=self.validation_ids["bidid"].values)
        # self.opponents_dfs["constant_0"] = pd.DataFrame({
        #     "bidprice": np.full((len(self.validation_ids, )), 0)
        # }, index=self.validation_ids["bidid"].values)

    def load_validation(self):
        usecols = {"slotwidth", "slotheight", "slotarea", "weekday", "hour", "useragent", "region", "city",
                   "adexchange", "domain", "slotid", "slotvisibility", "slotformat", "slotprice",
                   "creative", "keypage", "advertiser", "os", "browser"}

        categories = {"useragent", "IP", "region", "city", "adexchange", "domain", "url",
                      "urlid", "slotid", "slotvisibility", "creative", "keypage", "advertiser", "slotformat",
                      "os", "browser"}

        one_row = pd.read_csv(validation_path, nrows=1)

        usecols = [x for x in one_row.columns if x in usecols or "usertag_" in x]

        categories = {k: "category" for k in usecols if (k in categories or "usertag_" in k)}

        dataset = pd.read_csv(validation_path, usecols=usecols, dtype=categories)

        ids = pd.read_csv(validation_path, usecols=["bidid"])

        y = pd.read_csv(validation_path, usecols=["bidid", "click", "payprice", "bidprice"], index_col="bidid")

        return dataset, y, ids

    def evaluate_bid(self):
        spent = defaultdict(int)
        won = defaultdict(set)

        order = {i + 1: k for i, k in enumerate(self.opponents_dfs.keys())}
        order[max(order.keys()) + 1] = "bid"

        ma_bids = []

        for i, bidid in tqdm(enumerate(self.validation_ids["bidid"].values), total=self.length):
            # if True:
            #     if self.bids.loc[bidid]["bidprice"] == 0:
            #
            #         max_bid = self.max_bid
            #         min_bid = self.validation_x.iloc[i]["slotprice"]
            #
            #         possible_bids = list(range(min_bid, min(300, max_bid) + 1, 25)) + [max_bid]
            #         ps = CTR_WHEN_BID.get(min_bid, AVERAGE_CTR)
            #
            #         values = []
            #
            #         p = self.predictions[i]
            #
            #         for b in possible_bids:
            #             pb = CTR_WHEN_BID.get(b, AVERAGE_CTR)
            #
            #             bidder_matrix = [[-0.00001, p / ps],
            #                              [-0.00001, p / pb]]
            #             publisher_matrix = [[0, min_bid],
            #                                 [min_bid - b, b]]
            #
            #             game = nashpy.Game(bidder_matrix, publisher_matrix)
            #
            #             try:
            #                 enumerations = list(game.support_enumeration())
            #                 equlibrium = random.choice(enumerations)
            #             except Exception:
            #                 continue
            #
            #             value = game[equlibrium]
            #             value = value[0]
            #
            #             values.append([b, value])
            #
            #         if len(values) != 0:
            #             values = sorted(values, key=lambda x: (x[1], -x[0]), reverse=True)
            #
            #             bid, value = values[0]
            #
            #             if value <= 0:
            #                 bid = 0
            #         else:
            #             bid = 0
            #     else:
            #         bid = self.bids.loc[bidid]["bidprice"]
            # else:
            #     bid = 0
            bid = 0

            ma_bids.append(bid)

            bids = np.array([self.validation_y.loc[bidid]["payprice"]] + [
                (df.loc[bidid]["bidprice"] if spent[k] < BUDGET else 0) for k, df in self.opponents_dfs.items()
            ] + [bid if spent["bid"] < BUDGET else 0])

            won_id, price_id = np.argsort(-bids)[:2]

            if won_id == 0:  # nobody beat the payprice
                continue

            won[order[won_id]].add(bidid)
            spent[order[won_id]] += bids[price_id]

        results = {}

        for k in won.keys():
            won_subset = self.validation_y[self.validation_y.index.isin(won[k])]

            impressions = len(won_subset)
            clicks = won_subset["click"].sum()
            paid = spent[k]

            results[k] = LinearBidder.stats(paid, impressions, clicks)

        pprint(results)

        # Path("results/ma_comparison.json").write_text(json.dumps(results, default=default, indent=2, sort_keys=True))
        #
        # ma_bids = pd.DataFrame({"bidid": self.validation_ids["bidid"].values,
        #                         "bidprice": ma_bids})
        # ma_bids.to_csv("results/val_bid_ma.csv", index=None)


if __name__ == "__main__":
    bidder = MultiAgentBidder()

    bidder.evaluate_bid()
